//////////////////////////////////////////////////////////////////////////
//
//					TvvORuPTpY@ǔłQv
//									C[W̎쐬@xAbv
//												Programmed By T.Tanabe
//
//							BGMƉ摜̒쌠F Aris Multimedia Entertainment, Inc. 1993


// eC|[g
import java.applet.*;
import java.awt.*;
import java.util.Random;
import java.awt.image.CropImageFilter;
import java.awt.image.FilteredImageSource;
import java.awt.image.ImageFilter;

// CAvbg
public class Puzzle15 extends Applet implements Runnable {
	String	sPuzzleFile = "DefaultPict";	// w̖Ƃ̃t@C
	int				iMoveCnt = 0;
	AudioClip		auClick, auBgm;
	Thread			thread = null;
	PuzzleCanvas	PCanvas;
	Label			lblMoveCnt;
	
	// N̏
	public void init() {
		String s;
		
		// p[^̎w肪ꍇAt@CύX
		if ((s = getParameter("file")) != null) { sPuzzleFile = s; };
		
		PCanvas = new PuzzleCanvas();
		
		// C[W̓ǂݍ݁ݒ
		showStatus("Now Data Loading ...");
		MediaTracker mt = new MediaTracker(this);
		Image img = getImage(getDocumentBase(), "Images/"+sPuzzleFile+".gif");
		mt.addImage(img, 0);
		try {
			mt.waitForID(0);
		} catch(InterruptedException e) return;
		PCanvas.setImage(img);
		
		// TEh̐ݒ
		auBgm	= getAudioClip(getDocumentBase(), "Sounds/BGM.au");
		auClick = getAudioClip(getDocumentBase(), "Sounds/Click.au");
		
		// ʉ̃JEg\j[Q[{^̐ݒ
		lblMoveCnt = new Label("Move Count = 0", Label.LEFT);
		Panel pnl = new Panel();
		pnl.setLayout(new GridLayout(1,2, 100, 0));
		pnl.add(lblMoveCnt);
		pnl.add(new Button("New Game"));
		
		setLayout(new BorderLayout());
		add("Center", PCanvas);
		add("South", pnl);
	}
	
	// Avbg͂̋󔒐ݒiCZbgj
	public Insets insets() {
		return new Insets(10, 10, 10, 10);
	}

	// AvbgJnĊJ
	public void start() {
		if (thread == null) {
			thread = new Thread(this);
			thread.start();
		}	
	}
	
	// Xbhs
	public void run() {
		if (auBgm != null)	auBgm.loop();
	}
	
	// Avbgꎞ~
	public void stop() {
		if (thread != null) {
			auBgm.stop();
			thread.stop();
			thread = null;
		}
	}
	
	//ANVCxg̏
	public boolean action(Event evt, Object what) {
		if (evt.target instanceof Button) {
			// New Game{^ꂽQ[Ԃɂ
			PCanvas.InitAll();
			PCanvas.repaint();
			lblMoveCnt.setText("Move Count = 0");
			iMoveCnt = 0;
			showStatus("");
			return true;
		}
		return false;
	}

	// }EX_ECxg̏
	public boolean mouseDown(Event evt, int x, int y) {
		if (evt.target instanceof PuzzleCanvas && PCanvas.bClear == false) {
			// }EX_EpYGAɑ΂ĔiQ[̂݁j
			int mx = x / PuzzleCanvas.PARTS_SIZE, 
				my = y / PuzzleCanvas.PARTS_SIZE;
			
			int bx = PCanvas.getBlinkX(), by = PCanvas.getBlinkY();
			if ((mx == bx || my == by) && (mx - bx + my - by) != 0) {
				// wCx̂ǂ炩vƂ
				while(mx - bx + my - by != 0) {
					// ړ\ȌuNړ
					if (mx < bx)		PCanvas.MoveBlink(PuzzleCanvas.LEFT);
					else if (mx > bx) 	PCanvas.MoveBlink(PuzzleCanvas.RIGHT);
					else if (my < by) 	PCanvas.MoveBlink(PuzzleCanvas.UP);
					else if (my > by) 	PCanvas.MoveBlink(PuzzleCanvas.DOWN);
					bx = PCanvas.getBlinkX(); by = PCanvas.getBlinkY();
				}
				PCanvas.repaint();
				iMoveCnt = iMoveCnt + 1;
				lblMoveCnt.setText("Move Count = " + iMoveCnt);
				auClick.play();
				// NA`FbN
				if (PCanvas.isClear()) {
					PCanvas.GameClear();
					showStatus("Game Clear!!");
				}
				return true;
			}
		}
		return false;
	}
}

// pYLoXp̃NX
class PuzzleCanvas extends Canvas {
	// 萔`
	static final int UP				= 0;
	static final int RIGHT			= 1;
	static final int DOWN			= 2;
	static final int LEFT				= 3;
	static final int PARTS_SIZE 	= 60;
	static final int PUZZLE_SIZE		= 4;
	static final int PARTS_MAX		= PUZZLE_SIZE * PUZZLE_SIZE;
	
	static Random random = new Random();
	Rectangle rc = new Rectangle(0, 0, 
						PARTS_SIZE * PUZZLE_SIZE, PARTS_SIZE * PUZZLE_SIZE);
	Image	imgOrignal, imgParts[] = new Image[PARTS_MAX];
	int		iArea[] = new int[PARTS_MAX];
	int		iBlink;
	boolean	bClear;
	boolean bFirstDraw = true;
	
	// RXgN^
	PuzzleCanvas() {
		InitAll();
	}
	
	public int getBlinkX() {	return iBlink % PUZZLE_SIZE;	}
	public int getBlinkY() {	return iBlink / PUZZLE_SIZE;	}
	public int indexToX(int n) {	return n % PUZZLE_SIZE;	}
	public int indexToY(int n) {	return n / PUZZLE_SIZE;	}
		
	// pỸC[WZbg郁]bg
	public void setImage(Image img) {
		imgOrignal = img;	
		ImageFilter cropImg;
		Graphics	g;
		MediaTracker mt = new MediaTracker(this);
		for (int i = 0; i < PARTS_MAX; i++) {
			cropImg = new CropImageFilter(indexToX(i) * PARTS_SIZE, 
				indexToY(i) * PARTS_SIZE, PARTS_SIZE, PARTS_SIZE);
       		imgParts[i] = createImage(new FilteredImageSource(
       									img.getSource(), cropImg));
			mt.addImage(imgParts[i], 1);
       	}
		try {
			mt.waitForID(1);
		} catch(InterruptedException e) return;
	}
	
	// ĕ`̃I[o[Cg
	public void update(Graphics g) {
		g.clipRect(rc.x, rc.y, rc.width, rc.height);
		paint(g);
		bFirstDraw = true;
	}
	
	// `揈
	public void paint(Graphics g) {
		g.drawImage(imgOrignal, 250, 0, 120, 120, this);
		for (int i = 0; i < PARTS_MAX; i++) drawParts(g, i);
	}
	
	// pỸp[cP`悷
	public void drawParts(Graphics g, int pos) {
		int x = indexToX(pos) * PARTS_SIZE,
			y = indexToY(pos) * PARTS_SIZE;
	
		if (pos != iBlink || bClear)
			g.drawImage(imgParts[iArea[pos]], x, y, this);
		
		if (bClear == false) {
			if (pos != iBlink)
				g.drawRect(x, y, PARTS_SIZE - 1, PARTS_SIZE - 1);
			else
				g.fillRect(x, y, PARTS_SIZE, PARTS_SIZE);
		}
	}
	
	//Sď
	public void InitAll() {
		for (int i = 0; i < PARTS_MAX; i++) iArea[i] = i;
		iBlink = Math.abs(random.nextInt() % PARTS_MAX);
		Shafull();
		bClear = false;
		bFirstDraw = true;
		rc.reshape(0, 0, PARTS_SIZE * PUZZLE_SIZE + 130, PARTS_SIZE * PUZZLE_SIZE);
	}
	
	// pYp[cVbt
	public void Shafull() {
		for (int i = 0; i < 500; i++)
			MoveBlink(Math.abs(random.nextInt() % 4));
	}
	
	// uNJ[\̈ړ
	public void MoveBlink(int iDir) {
		int movOfs[] = {-PUZZLE_SIZE, 1, PUZZLE_SIZE, -1};
		
		if (isMoveOK(iDir)) {
			if (bFirstDraw) {
				// \An߂̕`̓Nbv̂߂̏ݒ
				bFirstDraw = false;
				rc.reshape(getBlinkX() * PARTS_SIZE, 
						getBlinkY() * PARTS_SIZE, PARTS_SIZE, PARTS_SIZE);
			} else {
				// Qڈȍ~́AȑO͈̔͂ɒǉ
				rc.add(new Rectangle(getBlinkX() * PARTS_SIZE, 
						getBlinkY() * PARTS_SIZE, PARTS_SIZE, PARTS_SIZE));
			}
			int tmp = iArea[iBlink + movOfs[iDir]];
			iArea[iBlink + movOfs[iDir]] = iArea[iBlink];
			iArea[iBlink] = tmp;
			iBlink = iBlink + movOfs[iDir];
			rc.add(new Rectangle(getBlinkX() * PARTS_SIZE, 
						getBlinkY() * PARTS_SIZE, PARTS_SIZE, PARTS_SIZE));
		}
	}
	
	// uNJ[\̎wړ\ׂ
	boolean isMoveOK(int dir) {
		switch(dir) {
		case LEFT:	return getBlinkX() != 0;
		case RIGHT:	return getBlinkX() != (PUZZLE_SIZE - 1);
		case UP:	return getBlinkY() > 0;
		case DOWN:	return getBlinkY() < (PUZZLE_SIZE - 1);
		}
		return false;
	}
	
	// pYǂ𒲂ׂ
	public boolean isClear() {
		for (int i = 0; i < PARTS_MAX; i++) {
			if (iArea[i] != i) return false;
		}
		return true;
	}
	
	// pYƂ̏
	public void GameClear() {
		bClear = true;
		rc.reshape(0, 0, PARTS_SIZE * PUZZLE_SIZE, PARTS_SIZE * PUZZLE_SIZE);
		repaint();
	}
}

